Bug 255996 - [mixeddev] stepping from Java into native sometimes stays in disassembly
[mixeddev] stepping from Java into native sometimes stays in disassembly
Status: STARTED
Product: cnd
Classification: Unclassified
Component: Debugger
8.1
All All
: P3 (vote)
: Dev
Assigned To: Maria Tishkova
issues@cnd
CR_20513293, 82patch-candidate
:
: 258180 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-18 12:22 UTC by Vladimir Kvashin
Modified: 2016-12-15 19:08 UTC (History)
1 user (show)

See Also:
Issue Type: DEFECT
:


Attachments
This have just repeated. Here is gdb log (25.61 KB, text/plain)
2015-10-18 15:42 UTC, Vladimir Kvashin
Details
One more case when it stays in disassembly. (25.61 KB, text/plain)
2015-10-18 16:05 UTC, Vladimir Kvashin
Details
The patch makes current location more accurate (3.20 KB, patch)
2016-04-11 10:36 UTC, henk89
Details | Diff
The patch makes current location more accurate (2.97 KB, patch)
2016-04-11 15:56 UTC, henk89
Details | Diff
proposed patch (6.20 KB, patch)
2016-04-13 15:04 UTC, henk89
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Vladimir Kvashin 2015-10-18 12:22:18 UTC
Several times stepping from Java into native went ok, but disassembly window became focused. When I switched focus to appropriate .cpp file, I saw green breakpoint line there, and everythink worked ok.

Frankly that was probably Studio specific.
Comment 1 Vladimir Kvashin 2015-10-18 15:42:05 UTC
Created attachment 156783 [details]
This have just repeated. Here is gdb log

But it seems to be rather an issue of synchronization somewhere in NB
Comment 2 Vladimir Kvashin 2015-10-18 16:05:55 UTC
Created attachment 156785 [details]
One more case when it stays in disassembly.

One more case when it stays in disassembly.
And yes, it is a pure NetBeans problem - today I'm running NetBeans, not Studio.

Again, as soon as I manually switched to .cpp, everything works fine.
Comment 3 soldatov 2015-10-18 16:45:12 UTC
I think you speak about CR 20513293. Every day 5-10 automatic tests fails because Disassembly tab appears. Easy reproduce via NetBeans and Attach window.
Comment 4 henk89 2016-04-11 10:34:59 UTC
The root cause of the issue is the sync problem in NativeDebuggerImpl.updateLocation(): the outcome depends on the order of the execution of SwingUtilities.invokeLater. Sometimes file operations inside run() change the execution order that results in showing outdated location (including disassembled code)
Comment 5 henk89 2016-04-11 10:36:42 UTC
Created attachment 159203 [details]
The patch makes current location more accurate
Comment 6 henk89 2016-04-11 15:56:11 UTC
Created attachment 159212 [details]
The patch makes current location more accurate
Comment 7 henk89 2016-04-13 15:04:50 UTC
Created attachment 159254 [details]
proposed patch
Comment 8 henk89 2016-04-14 10:09:04 UTC
Fixed in:
http://hg.netbeans.org/cnd-main/rev/5e5963338e48
Comment 9 Quality Engineering 2016-04-15 01:46:58 UTC
Integrated into 'main-silver', will be available in build *201604150001* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)

Changeset: http://hg.netbeans.org/main-silver/rev/5e5963338e48
User: Nikolay Koldunov <henk89@netbeans.org>
Log: Fixed #255996 - [mixeddev] stepping from Java into native sometimes stays in disassembly
Comment 10 Vladimir Kvashin 2016-04-15 16:59:51 UTC
verified in builds on enum server
Comment 11 Alexander Pepin 2016-04-20 15:44:41 UTC
The issue is not fixed yet in patch from staging UC.
Comment 12 Alexander Pepin 2016-04-20 15:49:20 UTC
It looks like opening the java source file in the editor before starting debugger makes difference.
Comment 13 Maria Tishkova 2016-08-19 14:18:36 UTC
*** Bug 258180 has been marked as a duplicate of this bug. ***


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2014, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo